// by Desaxismundi

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//transforms
float4x4 tWVP: WORLDVIEWPROJECTION;

///////////////////////////////////////
//TEXTURES/////////////////////////////
///////////////////////////////////////

//Source Texture /////////////////////////////////
texture Tex2 <string uiname="Texture";>;
float4x4 tTex2: TEXTUREMATRIX <string uiname="Texture Transform";>;
sampler Samp2 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex2);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

//Control Texture /////////////////////////////////
texture Tex <string uiname="Control Texture";>;
float4x4 tTex: TEXTUREMATRIX <string uiname="Control Texture Transform";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

float4x4 tCol <string uiname="Color Transform";>;

//------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
//VS SIMPLE/////////////////////////////////////////////////
struct vs2ps
{
    float4 Pos        : POSITION;
    float4 TexCd      : TEXCOORD0;
    float4 TexCd2     : TEXCOORD1;
};


vs2ps VS(
    float4 Pos         : POSITION,
    float4 TexCd       : TEXCOORD0,
    float4 TexCd2      : TEXCOORD1)
{
    vs2ps Out = (vs2ps)0;

    Out.Pos = mul(Pos, tWVP);
    Out.TexCd2 = mul(TexCd, tTex2);
    Out.TexCd = mul(TexCd, tTex);

    return Out;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// -------------------------------------------------------------------------------------------------------------------------------------

float4 PS_TexCtrlInvert(vs2ps In): COLOR
{
    float4 col = tex2D(Samp, In.TexCd );
    float4 col2 = tex2D(Samp2, In.TexCd2);
    float4 col3 = {( (1,1,1) - col.rgb),1};
    float4 col4 = {( (1,1,1) - col2.rgb),1};
    float4 col5 =  (col*col4) ;
    float4 col6 =  (col3*col2) ;
    float4 col7 = col5 + col6 ;
    
    return mul(col7,tCol);
}

// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------


technique TexCtrlInvert {
pass p0
{
         VertexShader = compile vs_1_0 VS();
         PixelShader = compile ps_1_4 PS_TexCtrlInvert();
    }
}

//EOF//////////////////////////////////////////////////////////////////////////////////////////////////////////
